#your data Average_LatB (LatB roots - 42 s data)
#time
x<-c(-44,-43,-42,-41,-40,-39,-38,
     -37,-36,-35,-34,-33,-32,-31,-30,-29,-28,-27,-26,-25,-24,-23,-22,-21,-20,-19,-18,-17,-16,-15,-14,-13,
     -12,-11,-10,-9,-8,-7,-6,-5,-4,-3,-2,-1,0)
#intensity
y<-c(0.643957979,
     0.681171005,
     0.664472037,
     0.733070783,
     0.720816561,
     0.754934428,
     0.764434922,
     0.765922783,
     0.823936789,
     0.838224344,
     0.839494723,
     0.875909541,
     0.882841186,
     0.926700935,
     0.900668119,
     0.91534901,
     0.96303957,
     0.968259129,
     0.954126267,
     0.950952505,
     0.980999987,
     0.967909,
     0.990816379,
     0.96711949,
     0.9636669,
     1,
     0.995311309,
     0.971386799,
     0.989749947,
     0.962848134,
     0.976443246,
     0.988084092,
     0.978151332,
     0.938348293,
     0.920753679,
     0.914354343,
     0.899441878,
     0.896862377,
     0.879084233,
     0.825413487,
     0.852738589,
     0.813932403,
     0.75981288,
     0.736302032,
     0.742720901)
library(splines)
spline <- interpSpline(x,y)
plot(spline)
points(x,y)

library(ggplot2)
df<-as.data.frame(cbind(x,y))
g<-ggplot(df,aes(x,y))+stat_smooth(method="loess")+geom_smooth(method="loess")

fit<-loess(y~x,data=df)
#y predictions with loess fit in range of x
x.range<-min(df$x):max(df$x)
df$pred.y<-predict(fit,x.range)
df$pred.y

#df$pred.y is the loess smoothening points
#[1] 0.6352745 0.6614253 0.6865961 0.7108057 0.7340728 0.7564163 0.7778565 0.7983749 0.8179323 0.8364893 0.8540066 0.8704450
#[13] 0.8860803 0.9010702 0.9151974 0.9282447 0.9399950 0.9502311 0.9588344 0.9659578 0.9717915 0.9765256 0.9803504 0.9834091
#[25] 0.9855926 0.9867115 0.9865768 0.9849992 0.9817898 0.9771668 0.9713463 0.9641353 0.9553412 0.9447710 0.9325310 0.9188361
#[37] 0.9036568 0.8869637 0.8687275 0.8489185 0.8275338 0.8045967 0.7801178 0.7541075 0.7265764

#par(mfrow=c(3,1))
plot(df$x,df$y,main="original data")
plot(df$x,df$pred.y,main="loess prediction")


#first derivative is the slope (diff is pretty close)
slopes <- diff(df$pred.y)
#different lengths, let's just get rid of one point, let's say the last one
df<-df[-nrow(df),]
df$slopes<-slopes

plot(df$x,df$slopes,main="slopes")
abline(h=0,lwd=1,lty=2) #line at zero

#if first derivative is positve your intensity is growing
#if it's zero it's flattening
#if it's negative it is shrinking

#where is the slope closest to zero? peak
peak<-which.min(abs(slopes - 0))  
peak # 26th point of this dataset

df[26,] 


#      x y    pred.y        slopes
# 26 -19 1 0.9867115 -0.0001347292

#we need a scale (to be able to figure out what 20% of it is)
#split curve into before peak and after peak

left<-df[1:peak,]
right<-df[peak:nrow(df),]

#we use quantiles

#for the left side of the curve  # threshold 20% of the minimum
minl<-df$slopes[peak]

maxl<-max(left$slopes[1:(peak)])
lseq<-seq(minl,maxl,by=(maxl-minl)/100)
thrl<-quantile(lseq,0.2)
thr_x_left<-df$x[which.min(abs(df$slopes - thrl))]

#for the right side of the curve
maxr<-df$slopes[peak]
minr<-min(right$slopes)
rseq<-seq(minr,maxr,by=(maxr-minr)/100)
thrr<-quantile(rseq,0.8) 
thr_x_right<-df$x[which.min(abs(df$slopes - thrr))]

# we see how this thresholds look
#dev.off()
plot(df$x,df$y,main="original data",axes=FALSE)
axis(side=1, at=c(-44:0))
axis(side=2, at=seq(0.0, 1.0, by=0.1))
box()
abline(v=thr_x_left);abline(v=thr_x_right);abline(v=df$x[peak])
plot(spline)
points(x,y)
abline(v=thr_x_left);abline(v=thr_x_right);abline(v=df$x[peak])
plot(df$x,df$pred.y,main="loess prediction")
abline(v=thr_x_left);abline(v=thr_x_right);abline(v=df$x[peak])
plot(df$x,df$slopes,main="slopes")

abline(h=0,lwd=1,lty=2) #line at zero
abline(v=thr_x_left);abline(v=thr_x_right);abline(v=df$x[peak])

thr_x_right # phase transition from assembly
thr_x_left  # phase transition to scisison

## (-15,-24)

#here is how quantiles work just to check
#if you have a range of slopes, from 0.0007 to 0.18
s<-seq(0.0007,18,by=(18-0.0007)/100)
plot(s)
abline(h=quantile(s,0.2))
abline(h=quantile(s,0.5))
